diff --git a/target/linux/at91/sama7/config-default b/target/linux/at91/sama7/config-default
index 8c453659dc47..86fb4d4af663 100644
--- a/target/linux/at91/sama7/config-default
+++ b/target/linux/at91/sama7/config-default
@@ -49,7 +49,6 @@ CONFIG_BLK_DEV_RAM_COUNT=1
 CONFIG_BLK_DEV_RAM_SIZE=8192
 CONFIG_BLK_DEV_SD=y
 CONFIG_BLK_SCSI_REQUEST=y
-CONFIG_BRIDGE=m
 CONFIG_BT=y
 CONFIG_BT_DEBUGFS=y
 CONFIG_BT_HCIUART=y
@@ -57,14 +56,6 @@ CONFIG_BT_HCIUART=y
 CONFIG_BT_HCIVHCI=y
 # CONFIG_CACHE_L2X0 is not set
 CONFIG_CAN=y
-CONFIG_CFG80211=m
-CONFIG_CFG80211_CRDA_SUPPORT=y
-CONFIG_CFG80211_DEBUGFS=y
-# CONFIG_CFG80211_DEFAULT_PS is not set
-# CONFIG_CFG80211_DEVELOPER_WARNINGS is not set
-CONFIG_CFG80211_REQUIRE_SIGNED_REGDB=y
-CONFIG_CFG80211_USE_KERNEL_REGDB_KEYS=y
-CONFIG_CFG80211_WEXT=y
 CONFIG_CGROUPS=y
 # CONFIG_CGROUP_BPF is not set
 # CONFIG_CGROUP_CPUACCT is not set
@@ -194,6 +185,7 @@ CONFIG_GENERIC_ALLOCATOR=y
 CONFIG_GENERIC_BUG=y
 CONFIG_GENERIC_CLOCKEVENTS=y
 CONFIG_GENERIC_CPU_AUTOPROBE=y
+CONFIG_GENERIC_CPU_VULNERABILITIES=y
 CONFIG_GENERIC_EARLY_IOREMAP=y
 CONFIG_GENERIC_GETTIMEOFDAY=y
 CONFIG_GENERIC_IDLE_POLL_SETUP=y
@@ -215,7 +207,6 @@ CONFIG_GLOB=y
 CONFIG_GPIOLIB=y
 CONFIG_GPIOLIB_IRQCHIP=y
 CONFIG_GRACE_PERIOD=y
-CONFIG_GRO_CELLS=y
 CONFIG_HANDLE_DOMAIN_IRQ=y
 CONFIG_HARDEN_BRANCH_PREDICTOR=y
 CONFIG_HARDIRQS_SW_RESEND=y
@@ -256,23 +247,12 @@ CONFIG_JBD2=y
 CONFIG_KEYS=y
 CONFIG_LEDS_GPIO=y
 CONFIG_LIBFDT=y
-CONFIG_LLC=m
 CONFIG_LOCKD=y
 CONFIG_LOCK_DEBUGGING_SUPPORT=y
 CONFIG_LOG_BUF_SHIFT=16
 CONFIG_LSM="N"
 CONFIG_LZO_COMPRESS=y
 CONFIG_LZO_DECOMPRESS=y
-CONFIG_MAC80211=m
-# CONFIG_MAC80211_DEBUGFS is not set
-# CONFIG_MAC80211_DEBUG_MENU is not set
-CONFIG_MAC80211_HAS_RC=y
-# CONFIG_MAC80211_HWSIM is not set
-CONFIG_MAC80211_LEDS=y
-# CONFIG_MAC80211_MESH is not set
-CONFIG_MAC80211_RC_DEFAULT="minstrel_ht"
-CONFIG_MAC80211_RC_DEFAULT_MINSTREL=y
-CONFIG_MAC80211_RC_MINSTREL=y
 CONFIG_MACB=y
 CONFIG_MDIO_BUS=y
 CONFIG_MDIO_DEVICE=y
@@ -311,12 +291,9 @@ CONFIG_NEED_DMA_MAP_STATE=y
 CONFIG_NEED_PER_CPU_KM=y
 CONFIG_NEON=y
 # CONFIG_NET_CLS_CGROUP is not set
-CONFIG_NET_DEVLINK=y
-CONFIG_NET_DSA=m
 CONFIG_NET_NS=y
 CONFIG_NET_SWITCHDEV=y
 CONFIG_NFS_FS=y
-# CONFIG_NL80211_TESTMODE is not set
 CONFIG_NLS=y
 CONFIG_NLS_CODEPAGE_437=y
 CONFIG_NLS_CODEPAGE_850=y
@@ -348,7 +325,6 @@ CONFIG_PINCTRL=y
 CONFIG_PINCTRL_AT91=y
 CONFIG_PINCTRL_AT91PIO4=y
 CONFIG_PKCS7_MESSAGE_PARSER=y
-# CONFIG_PKCS7_TEST_KEY is not set
 # CONFIG_PKCS8_PRIVATE_KEY_PARSER is not set
 CONFIG_PM_OPP=y
 CONFIG_POWER_RESET=y
@@ -374,7 +350,6 @@ CONFIG_RTC_DRV_AT91RM9200=y
 CONFIG_RTC_DRV_AT91SAM9=y
 CONFIG_RTC_I2C_AND_SPI=y
 CONFIG_RTC_MC146818_LIB=y
-# CONFIG_RTL8723BS is not set
 # CONFIG_RUNTIME_TESTING_MENU is not set
 CONFIG_SAMA5D4_WATCHDOG=y
 CONFIG_SCSI=y
@@ -405,10 +380,9 @@ CONFIG_SND_SIMPLE_CARD_UTILS=y
 CONFIG_SND_SOC=y
 CONFIG_SND_SOC_GENERIC_DMAENGINE_PCM=y
 CONFIG_SND_SOC_I2C_AND_SPI=y
-CONFIG_SND_SOC_MIKROE_PROTO=m
+# CONFIG_SND_SOC_MIKROE_PROTO is not set
 CONFIG_SND_SOC_PCM5102A=y
 CONFIG_SND_SOC_SPDIF=y
-CONFIG_SND_SOC_WM8731=m
 CONFIG_SOC_BUS=y
 # CONFIG_SOC_SAMA5D2 is not set
 # CONFIG_SOC_SAMA5D3 is not set
@@ -425,18 +399,15 @@ CONFIG_SPI_ATMEL=y
 # CONFIG_SPI_ATMEL_QUADSPI is not set
 CONFIG_SPI_MASTER=y
 CONFIG_SPI_MEM=y
-CONFIG_SPI_SPIDEV=m
 CONFIG_SRCU=y
 CONFIG_STACKTRACE=y
 # CONFIG_STANDALONE is not set
-CONFIG_STP=m
 CONFIG_SUNRPC=y
 # CONFIG_SWAP is not set
 CONFIG_SWPHY=y
 # CONFIG_SWP_EMULATE is not set
 CONFIG_SYSFS_DEPRECATED=y
 CONFIG_SYSFS_DEPRECATED_V2=y
-CONFIG_SYSTEM_DATA_VERIFICATION=y
 # CONFIG_SYSTEM_EXTRA_CERTIFICATE is not set
 CONFIG_SYSTEM_TRUSTED_KEYRING=y
 CONFIG_SYS_SUPPORTS_APM_EMULATION=y
@@ -449,26 +420,19 @@ CONFIG_UNCOMPRESS_INCLUDE="debug/uncompress.h"
 CONFIG_UNWINDER_ARM=y
 # CONFIG_USER_NS is not set
 CONFIG_USE_OF=y
-CONFIG_V4L2_FWNODE=m
 CONFIG_V4L_PLATFORM_DRIVERS=y
 CONFIG_VFAT_FS=y
 CONFIG_VFP=y
 CONFIG_VFPv3=y
 # CONFIG_VIDEO_ATMEL_XISC is not set
 CONFIG_VIDEO_DEV=y
-CONFIG_VIDEO_IMX219=m
-CONFIG_VIDEO_IMX274=m
-CONFIG_VIDEO_OV5647=m
 CONFIG_VIDEO_V4L2=y
 CONFIG_VIDEO_V4L2_I2C=y
 CONFIG_VIDEO_V4L2_SUBDEV_API=y
-# CONFIG_VIRT_WIFI is not set
-CONFIG_VLAN_8021Q=m
 CONFIG_VT=y
 CONFIG_VT_CONSOLE=y
 # CONFIG_VT_HW_CONSOLE_BINDING is not set
 CONFIG_WATCHDOG_CORE=y
-# CONFIG_WFX is not set
 CONFIG_X509_CERTIFICATE_PARSER=y
 CONFIG_ZBOOT_ROM_BSS=0x0
 CONFIG_ZBOOT_ROM_TEXT=0x0